#property copyright "Lorentzos Roussos 2020"
#property link      "https://www.mql5.com/en/users/lorio"
#property strict
struct level_results
{
bool completed;
double importance,change;
datetime from,to;
level_results(void){completed=false;from=0;to=0;importance=0;change=0;}
};
level_results FindLevelImportance(double level,
                                  double previous_importance,
                                  int bar_from_old,
                                  int bar_to_new,
                                  bool volume_weighted,
                                  bool wicks_count,
                                  double importance_of_wicks,
                                  bool bodies_count,
                                  double importance_of_body,
                                  bool following_bar_counts,
                                  double importance_of_reaction)
{
level_results results;
if(bar_from_old>Bars-1||bar_from_old==-1){bar_from_old=Bars-1;}
if(bar_to_new<0){bar_to_new=0;}
if(bar_from_old>bar_to_new)
{
results.from=Time[bar_from_old];
results.to=Time[bar_to_new];
for(int i=bar_from_old;i>=bar_to_new;i--)
   {
   double oc_max=MathMax(Close[i],Open[i]);
   double oc_min=MathMin(Close[i],Open[i]);
   double this_score=0;
   //wicks 
   if(wicks_count&&((level>oc_max&&level<=High[i])||(level>=Low[i]&&level<oc_min))){this_score+=importance_of_wicks*Point();}
   //bodies
   if(bodies_count&&(level>=oc_min&&level<=oc_max)){this_score+=importance_of_body*Point();}
   //reaction and non 0
   if(following_bar_counts&&i>0)
     {
     //bullish bar 
       if(Close[i]>=Open[i])
       {
       this_score=(High[i]-Low[i-1])*importance_of_reaction;
       }
     //bearish bar 
       if(Close[i]<Open[i])
       {
       this_score=(High[i-1]-Low[i])*importance_of_reaction;
       }
     }
   results.importance+=this_score;
   }
if(previous_importance!=0)
  {
  double unit=previous_importance/100;
  double ch=(results.importance-previous_importance)/unit;
  results.change=ch;
  }
results.completed=true;
}
return(results);
}

level_results FindLevelImportance(double level,
                                  double previous_importance,
                                  datetime from,
                                  datetime to,
                                  bool volume_weighted,
                                  bool wicks_count,
                                  double importance_of_wicks,
                                  bool bodies_count,
                                  double importance_of_body,
                                  bool following_bar_counts,
                                  double importance_of_reaction)
{
level_results result;
int bfrom=iBarShift(_Symbol,_Period,from,false);
int bto=iBarShift(_Symbol,_Period,to,false);
if(bfrom!=-1&&bto!=-1){result=FindLevelImportance(level,previous_importance,bfrom,bto,volume_weighted,wicks_count,importance_of_wicks,bodies_count,importance_of_body,following_bar_counts,importance_of_reaction);}
return(result);
}
void ImportanceLevelInSpectrum(double &importance_array[])
{
  //find min and max 
  double min_importance=0,max_importance=0;
  for(int i=0;i<ArraySize(importance_array);i++)
  {
  if(i==0){min_importance=importance_array[i];max_importance=importance_array[i];}
  if(i>0)
    {
    if(importance_array[i]>max_importance){max_importance=importance_array[i];}
    if(importance_array[i]<min_importance){min_importance=importance_array[i];}
    }
  }
  double unit=(max_importance-min_importance)/100;
  if(unit>0)
  {
  for(int i=0;i<ArraySize(importance_array);i++)
  {
  importance_array[i]=(importance_array[i]-min_importance)/unit;
  }
  }
}

void ImportanceToRelativeImportance(double &importance_array[])
{
  double imp_sum=0;
  double min_importance=0;
  for(int i=0;i<ArraySize(importance_array);i++)
  {
  if(i==0){min_importance=importance_array[i];}
  if(i>0){if(importance_array[i]<min_importance){min_importance=importance_array[i];}}
  }  
  for(int i=0;i<ArraySize(importance_array);i++)
  {
  if(min_importance>=0){imp_sum+=importance_array[i];}
  if(min_importance<0){importance_array[i]+=MathAbs(min_importance);imp_sum+=importance_array[i];}
  }
  double unit=imp_sum/100;
  if(unit>0)
  {
  for(int i=0;i<ArraySize(importance_array);i++)
  {
  importance_array[i]=(importance_array[i])/unit;
  }
  }
}